Index: uspace/lib/c/arch/ia32/src/rtld/reloc.c
===================================================================
--- uspace/lib/c/arch/ia32/src/rtld/reloc.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/arch/ia32/src/rtld/reloc.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,5 +38,4 @@
 #include <stdlib.h>
 #include <inttypes.h>
-#include <str.h>
 
 #include <libarch/rtld/elf_dyn.h>
Index: uspace/lib/c/arch/ia32/src/stacktrace.c
===================================================================
--- uspace/lib/c/arch/ia32/src/stacktrace.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/arch/ia32/src/stacktrace.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -49,10 +49,10 @@
 }
 
-errno_t stacktrace_fp_prev(stacktrace_t *st, uintptr_t fp, uintptr_t *prev)
+int stacktrace_fp_prev(stacktrace_t *st, uintptr_t fp, uintptr_t *prev)
 {
 	return (*st->ops->read_uintptr)(st->op_arg, fp + FRAME_OFFSET_FP_PREV, prev);
 }
 
-errno_t stacktrace_ra_get(stacktrace_t *st, uintptr_t fp, uintptr_t *ra)
+int stacktrace_ra_get(stacktrace_t *st, uintptr_t fp, uintptr_t *ra)
 {
 	return (*st->ops->read_uintptr)(st->op_arg, fp + FRAME_OFFSET_RA, ra);
Index: uspace/lib/c/arch/ia64/src/stacktrace.c
===================================================================
--- uspace/lib/c/arch/ia64/src/stacktrace.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/arch/ia64/src/stacktrace.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -47,5 +47,5 @@
 }
 
-errno_t stacktrace_fp_prev(stacktrace_t *st, uintptr_t fp, uintptr_t *prev)
+int stacktrace_fp_prev(stacktrace_t *st, uintptr_t fp, uintptr_t *prev)
 {
 	(void) st; (void) fp; (void) prev;
@@ -53,5 +53,5 @@
 }
 
-errno_t stacktrace_ra_get(stacktrace_t *st, uintptr_t fp, uintptr_t *ra)
+int stacktrace_ra_get(stacktrace_t *st, uintptr_t fp, uintptr_t *ra)
 {
 	(void) st; (void) fp; (void) ra;
Index: uspace/lib/c/arch/mips32/src/stacktrace.c
===================================================================
--- uspace/lib/c/arch/mips32/src/stacktrace.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/arch/mips32/src/stacktrace.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -47,5 +47,5 @@
 }
 
-errno_t stacktrace_fp_prev(stacktrace_t *st, uintptr_t fp, uintptr_t *prev)
+int stacktrace_fp_prev(stacktrace_t *st, uintptr_t fp, uintptr_t *prev)
 {
 	(void) st; (void) fp; (void) prev;
@@ -53,5 +53,5 @@
 }
 
-errno_t stacktrace_ra_get(stacktrace_t *st, uintptr_t fp, uintptr_t *ra)
+int stacktrace_ra_get(stacktrace_t *st, uintptr_t fp, uintptr_t *ra)
 {
 	(void) st; (void) fp; (void) ra;
Index: uspace/lib/c/arch/ppc32/src/stacktrace.c
===================================================================
--- uspace/lib/c/arch/ppc32/src/stacktrace.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/arch/ppc32/src/stacktrace.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -49,10 +49,10 @@
 }
 
-errno_t stacktrace_fp_prev(stacktrace_t *st, uintptr_t fp, uintptr_t *prev)
+int stacktrace_fp_prev(stacktrace_t *st, uintptr_t fp, uintptr_t *prev)
 {
 	return (*st->ops->read_uintptr)(st->op_arg, fp + FRAME_OFFSET_FP_PREV, prev);
 }
 
-errno_t stacktrace_ra_get(stacktrace_t *st, uintptr_t fp, uintptr_t *ra)
+int stacktrace_ra_get(stacktrace_t *st, uintptr_t fp, uintptr_t *ra)
 {
 	return (*st->ops->read_uintptr)(st->op_arg, fp + FRAME_OFFSET_RA, ra);
Index: uspace/lib/c/arch/riscv64/src/stacktrace.c
===================================================================
--- uspace/lib/c/arch/riscv64/src/stacktrace.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/arch/riscv64/src/stacktrace.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,10 +39,10 @@
 }
 
-errno_t stacktrace_fp_prev(stacktrace_t *st, uintptr_t fp, uintptr_t *prev)
+int stacktrace_fp_prev(stacktrace_t *st, uintptr_t fp, uintptr_t *prev)
 {
 	return 0;
 }
 
-errno_t stacktrace_ra_get(stacktrace_t *st, uintptr_t fp, uintptr_t *ra)
+int stacktrace_ra_get(stacktrace_t *st, uintptr_t fp, uintptr_t *ra)
 {
 	return 0;
Index: uspace/lib/c/arch/sparc64/src/stacktrace.c
===================================================================
--- uspace/lib/c/arch/sparc64/src/stacktrace.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/arch/sparc64/src/stacktrace.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -50,8 +50,8 @@
 }
 
-errno_t stacktrace_fp_prev(stacktrace_t *st, uintptr_t fp, uintptr_t *prev)
+int stacktrace_fp_prev(stacktrace_t *st, uintptr_t fp, uintptr_t *prev)
 {
 	uintptr_t bprev;
-	errno_t rc;
+	int rc;
 
 	rc = (*st->ops->read_uintptr)(st->op_arg, fp + FRAME_OFFSET_FP_PREV, &bprev);
@@ -61,5 +61,5 @@
 }
 
-errno_t stacktrace_ra_get(stacktrace_t *st, uintptr_t fp, uintptr_t *ra)
+int stacktrace_ra_get(stacktrace_t *st, uintptr_t fp, uintptr_t *ra)
 {
 	return (*st->ops->read_uintptr)(st->op_arg, fp + FRAME_OFFSET_RA, ra);
Index: uspace/lib/c/generic/adt/circ_buf.c
===================================================================
--- uspace/lib/c/generic/adt/circ_buf.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/adt/circ_buf.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -82,5 +82,5 @@
  * @return EOK on success, EAGAIN if circular buffer is full
  */
-errno_t circ_buf_push(circ_buf_t *cbuf, const void *data)
+int circ_buf_push(circ_buf_t *cbuf, const void *data)
 {
 	if (circ_buf_nfree(cbuf) == 0)
@@ -99,5 +99,5 @@
  * @return EOK on success, EAGAIN if circular buffer is full
  */
-errno_t circ_buf_pop(circ_buf_t *cbuf, void *datab)
+int circ_buf_pop(circ_buf_t *cbuf, void *datab)
 {
 	if (cbuf->nused == 0)
Index: uspace/lib/c/generic/adt/odict.c
===================================================================
--- uspace/lib/c/generic/adt/odict.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/adt/odict.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -92,7 +92,7 @@
  * @return EOK on success, EINVAL on failure
  */
-static errno_t odict_validate_tree(odlink_t *cur, int *rbd)
-{
-	errno_t rc;
+static int odict_validate_tree(odlink_t *cur, int *rbd)
+{
+	int rc;
 	int bd_a, bd_b;
 	int cur_d;
@@ -177,8 +177,8 @@
  * @param odict Ordered dictionary
  */
-errno_t odict_validate(odict_t *odict)
+int odict_validate(odict_t *odict)
 {
 	int bd;
-	errno_t rc;
+	int rc;
 
 	if (odict->root == NULL)
Index: uspace/lib/c/generic/arg_parse.c
===================================================================
--- uspace/lib/c/generic/arg_parse.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/arg_parse.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -65,5 +65,5 @@
  *
  */
-errno_t arg_parse_int(int argc, char *argv[], int *index, int *value,
+int arg_parse_int(int argc, char *argv[], int *index, int *value,
     int offset)
 {
@@ -105,10 +105,10 @@
  *
  */
-errno_t arg_parse_name_int(int argc, char *argv[], int *index, int *value,
+int arg_parse_name_int(int argc, char *argv[], int *index, int *value,
     int offset, arg_parser parser)
 {
 	char *arg;
 	
-	errno_t ret = arg_parse_string(argc, argv, index, &arg, offset);
+	int ret = arg_parse_string(argc, argv, index, &arg, offset);
 	if (ret != EOK)
 		return ret;
@@ -135,5 +135,5 @@
  *
  */
-errno_t arg_parse_string(int argc, char **argv, int *index, char **value,
+int arg_parse_string(int argc, char **argv, int *index, char **value,
     int offset)
 {
Index: uspace/lib/c/generic/as.c
===================================================================
--- uspace/lib/c/generic/as.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/as.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -74,7 +74,7 @@
  *
  */
-errno_t as_area_resize(void *address, size_t size, unsigned int flags)
+int as_area_resize(void *address, size_t size, unsigned int flags)
 {
-	return (errno_t) __SYSCALL3(SYS_AS_AREA_RESIZE, (sysarg_t) address,
+	return __SYSCALL3(SYS_AS_AREA_RESIZE, (sysarg_t) address,
 	    (sysarg_t) size, (sysarg_t) flags);
 }
@@ -88,7 +88,7 @@
  *
  */
-errno_t as_area_destroy(void *address)
+int as_area_destroy(void *address)
 {
-	return (errno_t) __SYSCALL1(SYS_AS_AREA_DESTROY, (sysarg_t) address);
+	return __SYSCALL1(SYS_AS_AREA_DESTROY, (sysarg_t) address);
 }
 
@@ -102,7 +102,7 @@
  *
  */
-errno_t as_area_change_flags(void *address, unsigned int flags)
+int as_area_change_flags(void *address, unsigned int flags)
 {
-	return (errno_t) __SYSCALL2(SYS_AS_AREA_CHANGE_FLAGS, (sysarg_t) address,
+	return __SYSCALL2(SYS_AS_AREA_CHANGE_FLAGS, (sysarg_t) address,
 	    (sysarg_t) flags);
 }
@@ -117,7 +117,7 @@
  *
  */
-errno_t as_get_physical_mapping(const void *virt, uintptr_t *phys)
+int as_get_physical_mapping(const void *virt, uintptr_t *phys)
 {
-	return (errno_t) __SYSCALL2(SYS_PAGE_FIND_MAPPING, (sysarg_t) virt,
+	return (int) __SYSCALL2(SYS_PAGE_FIND_MAPPING, (sysarg_t) virt,
 	    (sysarg_t) phys);
 }
Index: uspace/lib/c/generic/assert.c
===================================================================
--- uspace/lib/c/generic/assert.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/assert.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,17 +41,5 @@
 static atomic_t failed_asserts = {0};
 
-void __helenos_assert_quick_abort(const char *cond, const char *file, unsigned int line)
-{
-	/*
-	 * Send the message safely to kio. Nested asserts should not occur.
-	 */
-	kio_printf("Assertion failed (%s) in file \"%s\", line %u.\n",
-	    cond, file, line);
-	
-	/* Sometimes we know in advance that regular printf() would likely fail. */
-	abort();
-}
-
-void __helenos_assert_abort(const char *cond, const char *file, unsigned int line)
+void assert_abort(const char *cond, const char *file, unsigned int line)
 {
 	/*
Index: uspace/lib/c/generic/async.c
===================================================================
--- uspace/lib/c/generic/async.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/async.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -205,5 +205,5 @@
 	ipc_call_t *dataptr;
 	
-	errno_t retval;
+	sysarg_t retval;
 } amsg_t;
 
@@ -332,5 +332,5 @@
 		msg->destroyed = false;
 		msg->dataptr = NULL;
-		msg->retval = EINVAL;
+		msg->retval = (sysarg_t) EINVAL;
 		awaiter_initialize(&msg->wdata);
 	}
@@ -511,5 +511,5 @@
 static FIBRIL_CONDVAR_INITIALIZE(avail_phone_cv);
 
-errno_t async_create_port(iface_t iface, async_port_handler_t handler,
+int async_create_port(iface_t iface, async_port_handler_t handler,
     void *data, port_id_t *port_id)
 {
@@ -698,5 +698,5 @@
  *
  */
-static errno_t connection_fibril(void *arg)
+static int connection_fibril(void *arg)
 {
 	assert(arg);
@@ -763,5 +763,5 @@
 	
 	free(fibril_connection);
-	return EOK;
+	return 0;
 }
 
@@ -844,8 +844,8 @@
  * @param port_id ID of the newly created port.
  *
- * @return Zero on success or an error code.
- *
- */
-errno_t async_create_callback_port(async_exch_t *exch, iface_t iface, sysarg_t arg1,
+ * @return Zero on success or a negative error code.
+ *
+ */
+int async_create_callback_port(async_exch_t *exch, iface_t iface, sysarg_t arg1,
     sysarg_t arg2, async_port_handler_t handler, void *data, port_id_t *port_id)
 {
@@ -860,8 +860,8 @@
 	    &answer);
 	
-	errno_t ret;
+	sysarg_t ret;
 	async_wait_for(req, &ret);
 	if (ret != EOK)
-		return (errno_t) ret;
+		return (int) ret;
 	
 	sysarg_t phone_hash = IPC_GET_ARG5(answer);
@@ -1051,11 +1051,10 @@
  * @param ucode   Top-half pseudocode handler.
  *
- * @param[out] handle  IRQ capability handle on success.
- *
- * @return An error code.
- *
- */
-errno_t async_irq_subscribe(int inr, async_notification_handler_t handler,
-    void *data, const irq_code_t *ucode, cap_handle_t *handle)
+ * @return IRQ capability handle on success.
+ * @return Negative error code.
+ *
+ */
+int async_irq_subscribe(int inr, async_notification_handler_t handler,
+    void *data, const irq_code_t *ucode)
 {
 	notification_t *notification =
@@ -1077,10 +1076,5 @@
 	futex_up(&async_futex);
 	
-	cap_handle_t cap;
-	errno_t rc = ipc_irq_subscribe(inr, imethod, ucode, &cap);
-	if (rc == EOK && handle != NULL) {
-		*handle = cap;
-	}
-	return rc;
+	return ipc_irq_subscribe(inr, imethod, ucode);
 }
 
@@ -1089,8 +1083,8 @@
  * @param cap     IRQ capability handle. 
  *
- * @return Zero on success or an error code.
- *
- */
-errno_t async_irq_unsubscribe(int cap)
+ * @return Zero on success or a negative error code.
+ *
+ */
+int async_irq_unsubscribe(int cap)
 {
 	// TODO: Remove entry from hash table
@@ -1106,8 +1100,8 @@
  * @param data    Notification handler client data.
  *
- * @return Zero on success or an error code.
- *
- */
-errno_t async_event_subscribe(event_type_t evno,
+ * @return Zero on success or a negative error code.
+ *
+ */
+int async_event_subscribe(event_type_t evno,
     async_notification_handler_t handler, void *data)
 {
@@ -1139,8 +1133,8 @@
  * @param data    Notification handler client data.
  *
- * @return Zero on success or an error code.
- *
- */
-errno_t async_event_task_subscribe(event_task_type_t evno,
+ * @return Zero on success or a negative error code.
+ *
+ */
+int async_event_task_subscribe(event_task_type_t evno,
     async_notification_handler_t handler, void *data)
 {
@@ -1173,5 +1167,5 @@
  *
  */
-errno_t async_event_unmask(event_type_t evno)
+int async_event_unmask(event_type_t evno)
 {
 	return ipc_event_unmask(evno);
@@ -1185,5 +1179,5 @@
  *
  */
-errno_t async_event_task_unmask(event_task_type_t evno)
+int async_event_task_unmask(event_task_type_t evno)
 {
 	return ipc_event_task_unmask(evno);
@@ -1437,5 +1431,5 @@
  *
  */
-static errno_t async_manager_worker(void)
+static int async_manager_worker(void)
 {
 	while (true) {
@@ -1489,14 +1483,13 @@
 		
 		ipc_call_t call;
-		errno_t rc = ipc_wait_cycle(&call, timeout, flags);
+		cap_handle_t chandle = ipc_wait_cycle(&call, timeout, flags);
 		
 		atomic_dec(&threads_in_ipc_wait);
 		
-		assert(rc == EOK);
-
-		if (call.cap_handle == CAP_NIL) {
-			if ((call.flags &
-			    (IPC_CALL_NOTIF | IPC_CALL_ANSWERED)) == 0) {
-				/* Neither a notification nor an answer. */
+		assert(chandle >= 0);
+
+		if (chandle == CAP_NIL) {
+			if (call.flags == 0) {
+				/* This neither a notification nor an answer. */
 				handle_expired_timeouts();
 				continue;
@@ -1507,5 +1500,5 @@
 			continue;
 
-		handle_call(call.cap_handle, &call);
+		handle_call(chandle, &call);
 	}
 
@@ -1521,5 +1514,5 @@
  *
  */
-static errno_t async_manager_fibril(void *arg)
+static int async_manager_fibril(void *arg)
 {
 	futex_up(&async_futex);
@@ -1597,5 +1590,5 @@
  *
  */
-void reply_received(void *arg, errno_t retval, ipc_call_t *data)
+void reply_received(void *arg, int retval, ipc_call_t *data)
 {
 	assert(arg);
@@ -1709,5 +1702,5 @@
  *
  */
-void async_wait_for(aid_t amsgid, errno_t *retval)
+void async_wait_for(aid_t amsgid, sysarg_t *retval)
 {
 	assert(amsgid);
@@ -1755,5 +1748,5 @@
  *
  */
-errno_t async_wait_timeout(aid_t amsgid, errno_t *retval, suseconds_t timeout)
+int async_wait_timeout(aid_t amsgid, sysarg_t *retval, suseconds_t timeout)
 {
 	assert(amsgid);
@@ -1856,15 +1849,16 @@
 void async_usleep(suseconds_t timeout)
 {
-	awaiter_t awaiter;
-	awaiter_initialize(&awaiter);
-	
-	awaiter.fid = fibril_get_id();
-	
-	getuptime(&awaiter.to_event.expires);
-	tv_add_diff(&awaiter.to_event.expires, timeout);
+	amsg_t *msg = amsg_create();
+	if (!msg)
+		return;
+	
+	msg->wdata.fid = fibril_get_id();
+	
+	getuptime(&msg->wdata.to_event.expires);
+	tv_add_diff(&msg->wdata.to_event.expires, timeout);
 	
 	futex_down(&async_futex);
 	
-	async_insert_timeout(&awaiter);
+	async_insert_timeout(&msg->wdata);
 	
 	/* Leave the async_futex locked when entering this function */
@@ -1872,4 +1866,6 @@
 	
 	/* Futex is up automatically after fibril_switch() */
+	
+	amsg_destroy(msg);
 }
 
@@ -1912,8 +1908,8 @@
  * @param r5      If non-NULL, storage for the 5th reply argument.
  *
- * @return Return code of the reply or an error code.
- *
- */
-errno_t async_req_fast(async_exch_t *exch, sysarg_t imethod, sysarg_t arg1,
+ * @return Return code of the reply or a negative error code.
+ *
+ */
+sysarg_t async_req_fast(async_exch_t *exch, sysarg_t imethod, sysarg_t arg1,
     sysarg_t arg2, sysarg_t arg3, sysarg_t arg4, sysarg_t *r1, sysarg_t *r2,
     sysarg_t *r3, sysarg_t *r4, sysarg_t *r5)
@@ -1926,5 +1922,5 @@
 	    &result);
 	
-	errno_t rc;
+	sysarg_t rc;
 	async_wait_for(aid, &rc);
 	
@@ -1964,8 +1960,8 @@
  * @param r5      If non-NULL, storage for the 5th reply argument.
  *
- * @return Return code of the reply or an error code.
- *
- */
-errno_t async_req_slow(async_exch_t *exch, sysarg_t imethod, sysarg_t arg1,
+ * @return Return code of the reply or a negative error code.
+ *
+ */
+sysarg_t async_req_slow(async_exch_t *exch, sysarg_t imethod, sysarg_t arg1,
     sysarg_t arg2, sysarg_t arg3, sysarg_t arg4, sysarg_t arg5, sysarg_t *r1,
     sysarg_t *r2, sysarg_t *r3, sysarg_t *r4, sysarg_t *r5)
@@ -1978,5 +1974,5 @@
 	    &result);
 	
-	errno_t rc;
+	sysarg_t rc;
 	async_wait_for(aid, &rc);
 	
@@ -2042,15 +2038,15 @@
 }
 
-errno_t async_answer_0(cap_handle_t chandle, errno_t retval)
+sysarg_t async_answer_0(cap_handle_t chandle, sysarg_t retval)
 {
 	return ipc_answer_0(chandle, retval);
 }
 
-errno_t async_answer_1(cap_handle_t chandle, errno_t retval, sysarg_t arg1)
+sysarg_t async_answer_1(cap_handle_t chandle, sysarg_t retval, sysarg_t arg1)
 {
 	return ipc_answer_1(chandle, retval, arg1);
 }
 
-errno_t async_answer_2(cap_handle_t chandle, errno_t retval, sysarg_t arg1,
+sysarg_t async_answer_2(cap_handle_t chandle, sysarg_t retval, sysarg_t arg1,
     sysarg_t arg2)
 {
@@ -2058,5 +2054,5 @@
 }
 
-errno_t async_answer_3(cap_handle_t chandle, errno_t retval, sysarg_t arg1,
+sysarg_t async_answer_3(cap_handle_t chandle, sysarg_t retval, sysarg_t arg1,
     sysarg_t arg2, sysarg_t arg3)
 {
@@ -2064,5 +2060,5 @@
 }
 
-errno_t async_answer_4(cap_handle_t chandle, errno_t retval, sysarg_t arg1,
+sysarg_t async_answer_4(cap_handle_t chandle, sysarg_t retval, sysarg_t arg1,
     sysarg_t arg2, sysarg_t arg3, sysarg_t arg4)
 {
@@ -2070,5 +2066,5 @@
 }
 
-errno_t async_answer_5(cap_handle_t chandle, errno_t retval, sysarg_t arg1,
+sysarg_t async_answer_5(cap_handle_t chandle, sysarg_t retval, sysarg_t arg1,
     sysarg_t arg2, sysarg_t arg3, sysarg_t arg4, sysarg_t arg5)
 {
@@ -2076,5 +2072,5 @@
 }
 
-errno_t async_forward_fast(cap_handle_t chandle, async_exch_t *exch,
+int async_forward_fast(cap_handle_t chandle, async_exch_t *exch,
     sysarg_t imethod, sysarg_t arg1, sysarg_t arg2, unsigned int mode)
 {
@@ -2085,5 +2081,5 @@
 }
 
-errno_t async_forward_slow(cap_handle_t chandle, async_exch_t *exch,
+int async_forward_slow(cap_handle_t chandle, async_exch_t *exch,
     sysarg_t imethod, sysarg_t arg1, sysarg_t arg2, sysarg_t arg3,
     sysarg_t arg4, sysarg_t arg5, unsigned int mode)
@@ -2105,8 +2101,8 @@
  * @param arg3            User defined argument.
  *
- * @return Zero on success or an error code.
- *
- */
-errno_t async_connect_to_me(async_exch_t *exch, sysarg_t arg1, sysarg_t arg2,
+ * @return Zero on success or a negative error code.
+ *
+ */
+int async_connect_to_me(async_exch_t *exch, sysarg_t arg1, sysarg_t arg2,
     sysarg_t arg3)
 {
@@ -2118,20 +2114,16 @@
 	    &answer);
 	
-	errno_t rc;
+	sysarg_t rc;
 	async_wait_for(req, &rc);
 	if (rc != EOK)
-		return (errno_t) rc;
+		return (int) rc;
 	
 	return EOK;
 }
 
-static errno_t async_connect_me_to_internal(int phone, sysarg_t arg1, sysarg_t arg2,
-    sysarg_t arg3, sysarg_t arg4, int *out_phone)
+static int async_connect_me_to_internal(int phone, sysarg_t arg1, sysarg_t arg2,
+    sysarg_t arg3, sysarg_t arg4)
 {
 	ipc_call_t result;
-	
-	// XXX: Workaround for GCC's inability to infer association between
-	// rc == EOK and *out_phone being assigned.
-	*out_phone = -1;
 	
 	amsg_t *msg = amsg_create();
@@ -2145,5 +2137,5 @@
 	    msg, reply_received);
 	
-	errno_t rc;
+	sysarg_t rc;
 	async_wait_for((aid_t) msg, &rc);
 	
@@ -2151,6 +2143,5 @@
 		return rc;
 	
-	*out_phone = (int) IPC_GET_ARG5(result);
-	return EOK;
+	return (int) IPC_GET_ARG5(result);
 }
 
@@ -2182,9 +2173,8 @@
 	}
 	
-	int phone;
-	errno_t rc = async_connect_me_to_internal(exch->phone, arg1, arg2, arg3,
-	    0, &phone);
-	if (rc != EOK) {
-		errno = rc;
+	int phone = async_connect_me_to_internal(exch->phone, arg1, arg2, arg3,
+	    0);
+	if (phone < 0) {
+		errno = phone;
 		free(sess);
 		return NULL;
@@ -2235,9 +2225,8 @@
 	}
 	
-	int phone;
-	errno_t rc = async_connect_me_to_internal(exch->phone, iface, arg2,
-	    arg3, 0, &phone);
-	if (rc != EOK) {
-		errno = rc;
+	int phone = async_connect_me_to_internal(exch->phone, iface, arg2,
+	    arg3, 0);
+	if (phone < 0) {
+		errno = phone;
 		free(sess);
 		return NULL;
@@ -2306,10 +2295,9 @@
 	}
 	
-	int phone;
-	errno_t rc = async_connect_me_to_internal(exch->phone, arg1, arg2, arg3,
-	    IPC_FLAG_BLOCKING, &phone);
-	
-	if (rc != EOK) {
-		errno = rc;
+	int phone = async_connect_me_to_internal(exch->phone, arg1, arg2, arg3,
+	    IPC_FLAG_BLOCKING);
+	
+	if (phone < 0) {
+		errno = phone;
 		free(sess);
 		return NULL;
@@ -2360,9 +2348,8 @@
 	}
 	
-	int phone;
-	errno_t rc = async_connect_me_to_internal(exch->phone, iface, arg2,
-	    arg3, IPC_FLAG_BLOCKING, &phone);
-	if (rc != EOK) {
-		errno = rc;
+	int phone = async_connect_me_to_internal(exch->phone, iface, arg2,
+	    arg3, IPC_FLAG_BLOCKING);
+	if (phone < 0) {
+		errno = phone;
 		free(sess);
 		return NULL;
@@ -2396,8 +2383,7 @@
 	}
 	
-	cap_handle_t phone;
-	errno_t rc = ipc_connect_kbox(id, &phone);
-	if (rc != EOK) {
-		errno = rc;
+	int phone = ipc_connect_kbox(id);
+	if (phone < 0) {
+		errno = phone;
 		free(sess);
 		return NULL;
@@ -2421,5 +2407,5 @@
 }
 
-static errno_t async_hangup_internal(int phone)
+static int async_hangup_internal(int phone)
 {
 	return ipc_hangup(phone);
@@ -2430,8 +2416,8 @@
  * @param sess Session to hung up.
  *
- * @return Zero on success or an error code.
- *
- */
-errno_t async_hangup(async_sess_t *sess)
+ * @return Zero on success or a negative error code.
+ *
+ */
+int async_hangup(async_sess_t *sess)
 {
 	async_exch_t *exch;
@@ -2444,5 +2430,5 @@
 	fibril_mutex_lock(&async_sess_mutex);
 	
-	errno_t rc = async_hangup_internal(sess->phone);
+	int rc = async_hangup_internal(sess->phone);
 	
 	while (!list_empty(&sess->exch_list)) {
@@ -2516,5 +2502,4 @@
 		} else if (mgmt == EXCHANGE_PARALLEL) {
 			int phone;
-			errno_t rc;
 			
 		retry:
@@ -2522,7 +2507,7 @@
 			 * Make a one-time attempt to connect a new data phone.
 			 */
-			rc = async_connect_me_to_internal(sess->phone, sess->arg1,
-			    sess->arg2, sess->arg3, 0, &phone);
-			if (rc == EOK) {
+			phone = async_connect_me_to_internal(sess->phone, sess->arg1,
+			    sess->arg2, sess->arg3, 0);
+			if (phone >= 0) {
 				exch = (async_exch_t *) malloc(sizeof(async_exch_t));
 				if (exch != NULL) {
@@ -2610,8 +2595,8 @@
  *              base address. Cannot be NULL.
  *
- * @return Zero on success or an error code from errno.h.
- *
- */
-errno_t async_share_in_start(async_exch_t *exch, size_t size, sysarg_t arg,
+ * @return Zero on success or a negative error code from errno.h.
+ *
+ */
+int async_share_in_start(async_exch_t *exch, size_t size, sysarg_t arg,
     unsigned int *flags, void **dst)
 {
@@ -2621,5 +2606,5 @@
 	sysarg_t _flags = 0;
 	sysarg_t _dst = (sysarg_t) -1;
-	errno_t res = async_req_2_4(exch, IPC_M_SHARE_IN, (sysarg_t) size,
+	int res = async_req_2_4(exch, IPC_M_SHARE_IN, (sysarg_t) size,
 	    arg, NULL, &_flags, NULL, &_dst);
 	
@@ -2673,5 +2658,5 @@
  *
  */
-errno_t async_share_in_finalize(cap_handle_t chandle, void *src, unsigned int flags)
+int async_share_in_finalize(cap_handle_t chandle, void *src, unsigned int flags)
 {
 	return ipc_answer_3(chandle, EOK, (sysarg_t) src, (sysarg_t) flags,
@@ -2685,8 +2670,8 @@
  * @param flags Flags to be used for sharing. Bits can be only cleared.
  *
- * @return Zero on success or an error code from errno.h.
- *
- */
-errno_t async_share_out_start(async_exch_t *exch, void *src, unsigned int flags)
+ * @return Zero on success or a negative error code from errno.h.
+ *
+ */
+int async_share_out_start(async_exch_t *exch, void *src, unsigned int flags)
 {
 	if (exch == NULL)
@@ -2743,5 +2728,5 @@
  *
  */
-errno_t async_share_out_finalize(cap_handle_t chandle, void **dst)
+int async_share_out_finalize(cap_handle_t chandle, void **dst)
 {
 	return ipc_answer_2(chandle, EOK, (sysarg_t) __entry, (sysarg_t) dst);
@@ -2771,8 +2756,8 @@
  * @param size Size of the destination buffer.
  *
- * @return Zero on success or an error code from errno.h.
- *
- */
-errno_t async_data_read_start(async_exch_t *exch, void *dst, size_t size)
+ * @return Zero on success or a negative error code from errno.h.
+ *
+ */
+int async_data_read_start(async_exch_t *exch, void *dst, size_t size)
 {
 	if (exch == NULL)
@@ -2848,5 +2833,5 @@
  *
  */
-errno_t async_data_read_finalize(cap_handle_t chandle, const void *src, size_t size)
+int async_data_read_finalize(cap_handle_t chandle, const void *src, size_t size)
 {
 	return ipc_answer_2(chandle, EOK, (sysarg_t) src, (sysarg_t) size);
@@ -2856,5 +2841,5 @@
  *
  */
-errno_t async_data_read_forward_fast(async_exch_t *exch, sysarg_t imethod,
+int async_data_read_forward_fast(async_exch_t *exch, sysarg_t imethod,
     sysarg_t arg1, sysarg_t arg2, sysarg_t arg3, sysarg_t arg4,
     ipc_call_t *dataptr)
@@ -2876,5 +2861,5 @@
 	}
 	
-	errno_t retval = ipc_forward_fast(chandle, exch->phone, 0, 0, 0,
+	int retval = ipc_forward_fast(chandle, exch->phone, 0, 0, 0,
 	    IPC_FF_ROUTE_FROM_ME);
 	if (retval != EOK) {
@@ -2884,8 +2869,8 @@
 	}
 	
-	errno_t rc;
+	sysarg_t rc;
 	async_wait_for(msg, &rc);
 	
-	return (errno_t) rc;
+	return (int) rc;
 }
 
@@ -2896,8 +2881,8 @@
  * @param size Size of the source buffer.
  *
- * @return Zero on success or an error code from errno.h.
- *
- */
-errno_t async_data_write_start(async_exch_t *exch, const void *src, size_t size)
+ * @return Zero on success or a negative error code from errno.h.
+ *
+ */
+int async_data_write_start(async_exch_t *exch, const void *src, size_t size)
 {
 	if (exch == NULL)
@@ -2973,5 +2958,5 @@
  *
  */
-errno_t async_data_write_finalize(cap_handle_t chandle, void *dst, size_t size)
+int async_data_write_finalize(cap_handle_t chandle, void *dst, size_t size)
 {
 	return ipc_answer_2(chandle, EOK, (sysarg_t) dst, (sysarg_t) size);
@@ -2999,5 +2984,5 @@
  *
  */
-errno_t async_data_write_accept(void **data, const bool nullterm,
+int async_data_write_accept(void **data, const bool nullterm,
     const size_t min_size, const size_t max_size, const size_t granularity,
     size_t *received)
@@ -3039,5 +3024,5 @@
 	}
 	
-	errno_t rc = async_data_write_finalize(chandle, arg_data, size);
+	int rc = async_data_write_finalize(chandle, arg_data, size);
 	if (rc != EOK) {
 		free(arg_data);
@@ -3062,5 +3047,5 @@
  *
  */
-void async_data_write_void(errno_t retval)
+void async_data_write_void(sysarg_t retval)
 {
 	cap_handle_t chandle;
@@ -3072,5 +3057,5 @@
  *
  */
-errno_t async_data_write_forward_fast(async_exch_t *exch, sysarg_t imethod,
+int async_data_write_forward_fast(async_exch_t *exch, sysarg_t imethod,
     sysarg_t arg1, sysarg_t arg2, sysarg_t arg3, sysarg_t arg4,
     ipc_call_t *dataptr)
@@ -3092,5 +3077,5 @@
 	}
 	
-	errno_t retval = ipc_forward_fast(chandle, exch->phone, 0, 0, 0,
+	int retval = ipc_forward_fast(chandle, exch->phone, 0, 0, 0,
 	    IPC_FF_ROUTE_FROM_ME);
 	if (retval != EOK) {
@@ -3100,8 +3085,8 @@
 	}
 	
-	errno_t rc;
+	sysarg_t rc;
 	async_wait_for(msg, &rc);
 	
-	return (errno_t) rc;
+	return (int) rc;
 }
 
@@ -3197,5 +3182,5 @@
 }
 
-errno_t async_state_change_start(async_exch_t *exch, sysarg_t arg1, sysarg_t arg2,
+int async_state_change_start(async_exch_t *exch, sysarg_t arg1, sysarg_t arg2,
     sysarg_t arg3, async_exch_t *other_exch)
 {
@@ -3225,5 +3210,5 @@
 }
 
-errno_t async_state_change_finalize(cap_handle_t chandle, async_exch_t *other_exch)
+int async_state_change_finalize(cap_handle_t chandle, async_exch_t *other_exch)
 {
 	return ipc_answer_1(chandle, EOK, other_exch->phone);
Index: uspace/lib/c/generic/bd.c
===================================================================
--- uspace/lib/c/generic/bd.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/bd.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -48,5 +48,5 @@
 static void bd_cb_conn(ipc_callid_t iid, ipc_call_t *icall, void *arg);
 
-errno_t bd_open(async_sess_t *sess, bd_t **rbd)
+int bd_open(async_sess_t *sess, bd_t **rbd)
 {
 	bd_t *bd = calloc(1, sizeof(bd_t));
@@ -59,5 +59,5 @@
 	
 	port_id_t port;
-	errno_t rc = async_create_callback_port(exch, INTERFACE_BLOCK_CB, 0, 0,
+	int rc = async_create_callback_port(exch, INTERFACE_BLOCK_CB, 0, 0,
 	    bd_cb_conn, bd, &port);
 	
@@ -83,5 +83,5 @@
 }
 
-errno_t bd_read_blocks(bd_t *bd, aoff64_t ba, size_t cnt, void *data, size_t size)
+int bd_read_blocks(bd_t *bd, aoff64_t ba, size_t cnt, void *data, size_t size)
 {
 	async_exch_t *exch = async_exchange_begin(bd->sess);
@@ -90,5 +90,5 @@
 	aid_t req = async_send_3(exch, BD_READ_BLOCKS, LOWER32(ba),
 	    UPPER32(ba), cnt, &answer);
-	errno_t rc = async_data_read_start(exch, data, size);
+	int rc = async_data_read_start(exch, data, size);
 	async_exchange_end(exch);
 
@@ -98,5 +98,5 @@
 	}
 
-	errno_t retval;
+	sysarg_t retval;
 	async_wait_for(req, &retval);
 
@@ -107,5 +107,5 @@
 }
 
-errno_t bd_read_toc(bd_t *bd, uint8_t session, void *buf, size_t size)
+int bd_read_toc(bd_t *bd, uint8_t session, void *buf, size_t size)
 {
 	async_exch_t *exch = async_exchange_begin(bd->sess);
@@ -113,5 +113,5 @@
 	ipc_call_t answer;
 	aid_t req = async_send_1(exch, BD_READ_TOC, session, &answer);
-	errno_t rc = async_data_read_start(exch, buf, size);
+	int rc = async_data_read_start(exch, buf, size);
 	async_exchange_end(exch);
 
@@ -121,5 +121,5 @@
 	}
 
-	errno_t retval;
+	sysarg_t retval;
 	async_wait_for(req, &retval);
 
@@ -130,5 +130,5 @@
 }
 
-errno_t bd_write_blocks(bd_t *bd, aoff64_t ba, size_t cnt, const void *data,
+int bd_write_blocks(bd_t *bd, aoff64_t ba, size_t cnt, const void *data,
     size_t size)
 {
@@ -138,5 +138,5 @@
 	aid_t req = async_send_3(exch, BD_WRITE_BLOCKS, LOWER32(ba),
 	    UPPER32(ba), cnt, &answer);
-	errno_t rc = async_data_write_start(exch, data, size);
+	int rc = async_data_write_start(exch, data, size);
 	async_exchange_end(exch);
 
@@ -146,5 +146,5 @@
 	}
 
-	errno_t retval;
+	sysarg_t retval;
 	async_wait_for(req, &retval);
 	if (retval != EOK)
@@ -154,9 +154,9 @@
 }
 
-errno_t bd_sync_cache(bd_t *bd, aoff64_t ba, size_t cnt)
-{
-	async_exch_t *exch = async_exchange_begin(bd->sess);
-
-	errno_t rc = async_req_3_0(exch, BD_SYNC_CACHE, LOWER32(ba),
+int bd_sync_cache(bd_t *bd, aoff64_t ba, size_t cnt)
+{
+	async_exch_t *exch = async_exchange_begin(bd->sess);
+
+	int rc = async_req_3_0(exch, BD_SYNC_CACHE, LOWER32(ba),
 	    UPPER32(ba), cnt);
 	async_exchange_end(exch);
@@ -165,10 +165,10 @@
 }
 
-errno_t bd_get_block_size(bd_t *bd, size_t *rbsize)
+int bd_get_block_size(bd_t *bd, size_t *rbsize)
 {
 	sysarg_t bsize;
 	async_exch_t *exch = async_exchange_begin(bd->sess);
 
-	errno_t rc = async_req_0_1(exch, BD_GET_BLOCK_SIZE, &bsize);
+	int rc = async_req_0_1(exch, BD_GET_BLOCK_SIZE, &bsize);
 	async_exchange_end(exch);
 
@@ -180,5 +180,5 @@
 }
 
-errno_t bd_get_num_blocks(bd_t *bd, aoff64_t *rnb)
+int bd_get_num_blocks(bd_t *bd, aoff64_t *rnb)
 {
 	sysarg_t nb_l;
@@ -186,5 +186,5 @@
 	async_exch_t *exch = async_exchange_begin(bd->sess);
 
-	errno_t rc = async_req_0_2(exch, BD_GET_NUM_BLOCKS, &nb_l, &nb_h);
+	int rc = async_req_0_2(exch, BD_GET_NUM_BLOCKS, &nb_l, &nb_h);
 	async_exchange_end(exch);
 
